%define name mkinitrd
%define version 3.1.6
%define release 11mdk
%define prefix %{_prefix}

Name: %{name}
Summary: Creates an initial ramdisk image for preloading modules.
Version: %{version}
Release: %{release}
License: GPL
Group: System/Kernel and hardware
Source: mkinitrd-%{version}.tar.bz2
Source1: mkinitrd_helper.tar.bz2
Patch0: mkinitrd-3.1.6-mdk.patch.bz2
Patch1: mkinitrd-3.1.6-mdkize-manpage.patch.bz2
Patch2: mkinitrd-3.1.6-mdkize-nash.patch.bz2
Patch3: mkinitrd-3.1.6-shutup-insmod-busybox.patch.bz2
Requires: mktemp >= 1.5-9mdk e2fsprogs /bin/sh fileutils grep mount gzip tar findutils gawk
%ifnarch %{ix86}
Requires: /sbin/insmod.static
%endif
BuildRoot: %{_tmppath}/%{name}-root

%description
Mkinitrd creates filesystem images for use as initial ramdisk (initrd)
images.  These ramdisk images are often used to preload the block
device modules (SCSI or RAID) needed to access the root filesystem.

In other words, generic kernels can be built without drivers for any
SCSI adapters which load the SCSI driver as a module.  Since the
kernel needs to read those modules, but in this case it isn't able to
address the SCSI adapter, an initial ramdisk is used.  The initial
ramdisk is loaded by the operating system loader (normally LILO) and
is available to the kernel as soon as the ramdisk is loaded.  The
ramdisk image loads the proper SCSI adapter and allows the kernel to
mount the root filesystem.  The mkinitrd program creates such a
ramdisk using information found in the /etc/modules.conf file.

%prep
%setup -q -a 1
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0

%build
make
%ifarch %{ix86}
cd mkinitrd_helper-subdir
make
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT
make BUILDROOT=$RPM_BUILD_ROOT mandir=%{_mandir} install
%ifarch %{ix86}
mkdir -p $RPM_BUILD_ROOT/sbin
cp mkinitrd_helper-subdir/insmod-busybox/insmod-DIET $RPM_BUILD_ROOT/sbin
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
/sbin/*
%{_mandir}/*/*

%changelog
* Sat Nov 17 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.1.6-11mdk
- use Greg Edwards <gedwards@fireweed.org> patch to fix problem where
  SCSI modules were not loaded in the correct order (gc)

* Tue Oct 16 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1.6-10mdk
- fix obsolete-tag Copyright
- fix strange-permission

* Sat Sep 22 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1.6-9mdk
- parses mount options to correctly feed the mount flags and the mount
  options

* Fri Sep 14 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1.6-8mdk
- integrate gb's patch to support ia64
- back to the use of insmod-from-busybox on ix86 arch, the 2.4 kernel
  is so large "mkbootdisk" fails in almost all situations now :-(
- refine Requires:

* Fri Sep 14 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1.6-7mdk
- argh, rootflags broke root on loopback, fix
- safety: when a mount with flags fails, try to mount without the flags

* Thu Sep 13 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1.6-6mdk
- remove duplicate scsi modules for safety

* Thu Sep 13 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1.6-5mdk
- use mount opts from /etc/fstab for root fs
- ifneeded -> force need when / is ext3 (for cases when ext3 would be non
  modular); and when / has mount opts
- try to sync man pages with actual code

* Sun Sep  9 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1.6-4mdk
- don't keep old bug of using 'ide-cd' module (juan)
- support new form of "probeall scsi_hostadapter" in modules.conf (pixel)
- don't load sd_mod and scsi_mod when not really needed (ide-scsi,
  usb-storage, etc) (pixel)
- support compressed modules with simpler stuff than ZMODULES
- when / is ext3 and we're on a 2.2 kernel, fallback to ext2
- don't use pivot_root with a 2.2 kernel, it's not implemented ;p

* Fri Sep  7 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1.6-3mdk
- support XFS (chmouel)
- say that our version is "3.1.6-mdk" to tell that it's patched for mdk

* Fri Sep  7 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1.6-2mdk
- honours quiet mode (again) (needed to fix a RH bug, ouch)

* Wed Sep  5 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1.6-1mdk
- synchronize with redhat stuff (for their way of mounting root fs)
- try to keep all (good) our patches, hope not too much is broken...

* Mon Aug 20 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.0.1-1mdk
- because of devfs, I need to have my special dev files in another
  directory than /dev, because devfs will shadow my dev files :-(
  (applies to loopback-on-/ and raid-on-/)
- use IS_IX86 instead of the is_ix86 function

* Fri Aug  3 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 3.0-1mdk
- we had a very large and silly patch on official 2.7 (385 lines of
  patch on a 450 lines original file), fork to ease maintainance
- merge RH interesting changes (mkinitrd-3.1.5 from RH)
  - added checks to load the modules i2o_block needs
  - skip errors finding jbd as a module if we're skipping them trying to find
  ext3 so that you can build a kernel with ext3 built-in and still use an
  initrd (MDK: we don't have ext3 yet, but we'll have it soon)
- prepend /(I|W|E):/ in front of all messages
- don't let "cat" fail on empty files in verbose mode

* Tue Apr 10 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 2.7-11mdk
- initrd_helper honours quiet mode
- rip rh idea to have a fake modprobe in order to remove kmod problems

* Fri Apr  6 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 2.7-10mdk
- import rh raid autorun stuff in mkinitrd_helper and mkinitrd
- grab a small rh raid fix (raid5 -> xor)
- use only one patch

* Fri Mar 23 2001 Pixel <pixel@mandrakesoft.com> 2.7-9mdk
- auto-adjust the number of inodes

* Sat Mar 17 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 2.7-8mdk
- use fix for insmod-busybox-dietlibc

* Fri Mar 16 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 2.7-7mdk
- use my own smaller code rather than sash+insmod.static for ix86

* Mon Mar  5 2001 Pixel <pixel@mandrakesoft.com> 2.7-6mdk
- compute the size really needed for initrd

* Sun Mar  4 2001 Pixel <pixel@mandrakesoft.com> 2.7-5mdk
- fix always making an initrd (ifneeded broken)

* Thu Mar  1 2001 Pixel <pixel@mandrakesoft.com> 2.7-4mdk
- fix last patch

* Tue Feb 27 2001 Pixel <pixel@mandrakesoft.com> 2.7-3mdk
- enable-use-of-gziped-modules.patch

* Sun Feb 11 2001 Pixel <pixel@mandrakesoft.com> 2.7-2mdk
- add require mktemp >= 1.5-9mdk (for option -d)

* Thu Dec 21 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 2.7-1mdk
- new and shiny source.

* Tue Nov 28 2000 Pixel <pixel@mandrakesoft.com> 2.6-2mdk
- fix typo patch. Still need a new mktemp that handles -d

* Sat Nov 25 2000 Pixel <pixel@mandrakesoft.com> 2.6-1mdk
- new version
- patch for case of no scsi needed and scsi_mod is in module

* Wed Aug 23 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.5-2mdk
- bug fix

* Mon Aug 21 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.5-1mdk
- update for hackkernel (new modules layout)
- remove exclusiveos:linux (rms'll be happy)
- make it noarch

* Fri Jul 28 2000 Pixel <pixel@mandrakesoft.com> 2.4.3-3mdk
- modified the mdk patch: don't do "insmod the.o || insmod -f the.o" because
sash doesn't handle it :(

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 2.4.3-2mdk
- BM

* Sun Jun 25 2000 Pixel <pixel@mandrakesoft.com> 2.4.3-1mdk
- merge with redhat (mainly modules.conf by default)

* Thu Jun  1 2000 Bill Nottingham <notting@redhat.com>
- build on ia64
- bump up initrd size on ia64
- modules.confiscation, /usr/man -> /usr/share/man

* Thu May 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.3.2-16mdk
- Thanks my god initrd work on alpha !!!.

* Tue May  9 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-15mdk
- add possibility to modules to ignore via env var IGNOREMODS

* Wed May  3 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-14mdk
- patch for skipping usb-storage

* Tue Apr 18 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-13mdk
- add handling of non-ext2 root filesytems (again :()

* Mon Apr 17 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-12mdk
- insmod -f instead of insmod

* Sat Mar 25 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-11mdk
- new group

* Sun Mar 19 2000 John Buswell <johnb@mandrakesoft.com> 2.3.2-10mdk
- Added ppc and k7 arch
- Fixed bzipping of man pages

* Mon Mar 13 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-9mdk
- do not require ash.static but sash
- add requires sash >= 3.4

* Mon Mar 13 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-8mdk
- add loopback handling

* Thu Jan  6 2000 Pixel <pixel@mandrakesoft.com>
- fix *buggy* grep scsi_hostadapter on conf.modules

* Mon Jan  3 2000 Pixel <pixel@mandrakesoft.com>
- fix to skip ide-scsi.o (overkill :)

* Tue Dec 28 1999 Pixel <pixel@mandrakesoft.com>
- fix to skip ppa.o and imm.o
- fix a typo

* Tue Oct 19 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- 2.3.2.

* Tue Apr 13 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Upgrade to 2.0.

* Sat Apr 10 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- Mandrake adaptions
- bzip2 man/info pages
- add de locale

* Thu Feb 25 1999 Matt Wilson <msw@redhat.com>
- updated description

* Mon Jan 11 1999 Matt Wilson <msw@redhat.com>
- Ignore the absence of scsi modules, include them if they are there, but
  don't complain if they are not.
- changed --no-scsi-modules to --omit-scsi-modules (as it should have been)

* Thu Nov  5 1998 Jeff Johnson <jbj@redhat.com>
- import from ultrapenguin 1.1.

* Tue Oct 20 1998 Jakub Jelinek <jj@ultra.linux.cz>
- fix for combined sparc/sparc64 insmod, also pluto module is really
  fc4:soc:pluto and we don't look at deps, so special case it.

* Sat Aug 29 1998 Erik Troan <ewt@redhat.com>
- replaced --needs-scsi-mods (which is now the default) with
  --omit-scsi-mods

* Fri Aug  7 1998 Jeff Johnson <jbj@redhat.com>
- correct obscure regex/shell interaction (hardwires tabs on line 232)

* Mon Jan 12 1998 Erik Troan <ewt@redhat.com>
- added 'make archive' rule to Makefile
- rewrote install procedure for more robust version handling
- be smarter about grabbing options from /etc/conf.modules

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- made it use /bin/ash.static

* Wed Apr 16 1997 Erik Troan <ewt@redhat.com>
- Only use '-s' to install binaries if /usr/bin/strip is present.
- Use an image size of 2500 if binaries can't be stripped (1500 otherwise)
- Don't use "mount -o loop" anymore -- losetup the proper devices manually
- Requires losetup, e2fsprogs

* Wed Mar 12 1997 Michael K. Johnson <johnsonm@redhat.com>
- Fixed a bug in parsing options.
- Changed to use a build tree, then copy the finished tree into the
  image after it is built.
- Added patches derived from ones written by Christian Hechelmann which
  add an option to put the kernel version number at the end of the module
  name and use install -s to strip binaries on the fly.
